/* Copyright 2010 ESRI
* 
* All rights reserved under the copyright laws of the United States
* and applicable international laws, treaties, and conventions.
* 
* You may freely redistribute and use this sample code, with or
* without modification, provided you include the original copyright
* notice and use restrictions.
* 
* See the use restrictions at http://help.arcgis.com/en/sdk/10.0/usageRestrictions.htm
* 
*/
package arcgissamples.addins.button;

import com.esri.arcgis.addins.desktop.Button;
import com.esri.arcgis.framework.IApplication;
import com.esri.arcgis.framework.IDockableWindow;
import com.esri.arcgis.framework.IDockableWindowManager;
import com.esri.arcgis.framework.IDockableWindowManagerProxy;
import com.esri.arcgis.system.UID;

public class ShowDocWinButton extends Button {
	IDockableWindow win;
	IDockableWindowManager dwm;
	UID uid;

	// Returns whether this button is checked
	public boolean isChecked() {
		return false;
	}

	// Returns whether this button is enabled
	public boolean isEnabled() {
		return true;
	}

	// This is called when the button is clicked
	public void onClick() {
		try {
			if (win != null){
				win.show(!win.isVisible());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/* This initializes the button.In this method you set the value of the dockable window id that you have 
	*  provided in the config.xml
	*/
	public void init(IApplication app) {
		try {
			
			dwm = new IDockableWindowManagerProxy(app);
			// Get the window id
			uid = new UID();
			//id attribute specified in the <DockableWindow> tag
			uid.setValue("dockableMap");
			win = dwm.getDockableWindow(uid);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
